<!DOCTYPE html>
<html>
  <head>
    <title>Editor: Waldgesellschaften</title>
    <script src="/assets/js/jsoneditor.min.js"></script>
    <script src="/assets/js/randomColor.min.js"></script>
    <link href="/assets/css/reset.min.css" rel="stylesheet">
    <link rel="stylesheet" href="/assets/css/fonts_googleapis_Frank_Ruhl_Libre_Source_Sans_Pro.css">
    <link rel="stylesheet" href="../assets/css/waldgesellschaften.css">
  </head>
  <body>
    <div class="grid-container" id="page-wrapper">
      <h1 class="grid-title">Waldgesellschaften</h1>
      <div class="grid-wg" id="wg-container"></div>
    </div>

    <div id="overlay" class="overlay"></div>
    <div id="overlay-editor" class="overlay-editor" ><div id='editor_holder'></div>
    <br><span id='valid_indicator' class="grid-valid"></span>
    </div>

  </body>

  <script>
    var data = [],
        id = false,
        wg = false
        // c = randomColor({hue: 'monochrome', luminosity: "dark", seed: 0293897463274876, format: "rgba", alpha: "0.6", count: 250})
        ;

// Load JSON Schema
    var jsonSchema;
    fetch('../api/schema-wg')
      .then(function(response) {return response.json();})
      .then(function(schema) {jsonSchema = schema})
      .then(function() {fetchData();})
      ;

// Load Waldgesellschaften from JSON
    function fetchData(){
      data = 0;
      fetch('../api/waldgesellschaften')
      .then(function(response) {return response.json();})
      .then(function(myJson) {data = myJson})
      .then(function() {console.log(data)})
      .then(function() {drawGrid();})
    ;};

// Initalize Json-Editor
        var editor = new JSONEditor(document.getElementById('editor_holder'),{
            // Enable fetching schemas via ajax
            ajax: true,

            // Set css theme
            theme: 'bootstrap4',
            iconlib: "none",

            // The schema for the editor
            schema: {$ref: "../api/schema-wg"},

            // Disable collapse
            disable_collapse: true,

            // Disable additional properties
            no_additional_properties: true,
            disable_properties: true,
            disable_edit_json: true,

            // Require all properties by default
            required_by_default: true
            });

// Parse Waldgesellschaften from JSON and draw to DOM
          function drawGrid(){
            for (var n in data){
                var staging = '', complete = 8;

                // css vaild id
                wg = 'wg' + ('000' + n).substr(-3)
                console.log(wg)
                // pw = Number(pw.substr(2));
                // console.log(pw)

                // // Read region
                // for (var key in data[n].region) {
                //     if (data[n].region[key]) {
                //         region += String(key) + ' '
                //     }
                // }

                // Check if Waldgesellschaft has content
                function isEmpty(obj) {
                    for(var key in obj) {
                        if(obj.hasOwnProperty(key))
                            return false;
                    }
                    return true;
                };

                if (isEmpty(data[n].RegCM3.more)) {complete = complete - 1};
                if (isEmpty(data[n].RegCM3.ok)) {complete = complete - 1};
                if (isEmpty(data[n].RegCM3.less)) {complete = complete - 1};
                if (isEmpty(data[n].RegCM3.achtung)) {complete = complete - 1};
                if (isEmpty(data[n].CLM.more)) {complete = complete - 1};
                if (isEmpty(data[n].CLM.ok)) {complete = complete - 1};
                if (isEmpty(data[n].CLM.less)) {complete = complete - 1};
                if (isEmpty(data[n].CLM.achtung)) {complete = complete - 1};
                //http://www.perbang.dk/rgbgradient/
                // var c = [ "#E36B16", "#E36B16", "#D9801C", "#CF9622", "#C6AB29", "#BCC12F", "#B2D635", "#A9EC3C", "#A9EC3C"]
                var c = [ "#fcde00", "#f2da01", "#e4d302", "#d2ca04", "#bfc106", "#acb807", "#99af09", "#8ba80a", "#7fa20b"]
                // var c = [ "#fcde00", "#f5dd03", "#ebdb06", "#ddd90a", "#cfd60f", "#c1d313", "#b3d118", "#a8cf1b", "#a1cd1d"]

                // console.log(c);

                // draw pathsegment to grid
                staging += '<div id="' + wg + '" onclick="editData(event)" class="waldgesellschaft" style="background-color:' + c[complete] + ';">' + data[n].wg + '</div>'
                document.getElementById('wg-container').innerHTML += staging;
            };
            console.log('gridDrawn')
            };


// Edit Data
        function editData(event) {
            var target = event.target || event.srcElement;
            wg = target.id;
            id = Number(wg.substr(2));
            document.getElementById("page-wrapper").classList.add("blur");
            document.getElementById('overlay').style.display = "block";
            document.getElementById('overlay-editor').style.display = "block";
            console.log('edit id: ' + id);
            editor.setValue();
            editor.setValue(data[id]);
        };

// Hide editor overlay and save data to server
        function updateGrid() {
            saveData();
            redrawGrid();
        };

// Validation Indicator of the JSON in the editor
        editor.on('change',function() {
            // Get an array of errors from the validator

            updateData();
            id = data.length + 1

            var errors = editor.validate();

            var indicator = document.getElementById('valid_indicator');

            // Not valid
            if(errors.length) {
                indicator.style.color = 'red';
                indicator.textContent = "not valid";
            }
            // Valid
            else {
                indicator.style.color = 'green';
                indicator.textContent = "valid";
            }
        });


// Update Data
        function updateData() {
            var dataNew = editor.getValue(); // check if editor is empty
            id = Number(wg.substr(2));

                if (dataNew.length > 0) {  // Data Update
                    data[id] = dataNew[0];
                    // console.log('data got updated: ' + JSON.stringify(data[id]))
                };

            console.log('data updated');
        };


// Button: Update Segment
        document.getElementById('overlay').addEventListener('click', function(){
            updateGrid();
            document.getElementById("page-wrapper").classList.remove("blur");
            document.getElementById('overlay').style.display = "none";
            document.getElementById('overlay-editor').style.display = "none";
        });


// Save and upload to projektionswege.json
        var xhttp = new XMLHttpRequest();
        var urlUpload='../api/editor-wg-update';

        function saveData() {
            // console.log("I sent: " + JSON.stringify(data));
            xhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    console.log(xhttp.responseText);
                }
            };
            var dataClean = data.filter(function (el) {
                return el != null;
            });
            data = dataClean;

            xhttp.open("POST", urlUpload, true);
            xhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            xhttp.send(JSON.stringify(dataClean)); //dataClean
            // console.log('User sent: ' + JSON.stringify(dataClean)); //dataClean
            console.log('data saved'); //dataClean
        };

// Purge grid
function redrawGrid() {
            var reset = '';
            document.getElementById('wg-container').innerHTML = reset;
            drawGrid();
            console.log('grid redrawn')
            };


      </script>
</html>
